;;; Gacela, a GNU Guile extension for fast games development
;;; Copyright (C) 2016 by Javier Sancho Fernandez <jsf at jsancho dot org>
;;;
;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (gacela scene)
  #:use-module (gacela game)
  #:use-module (srfi srfi-9)
  #:use-module (srfi srfi-9 gnu)
  #:export (make-scene
	    display-scene
	    run-scene))


;;; Scene Type

(define-record-type <scene>
  (make-scene name procedure)
  scene?
  (name scene-name)
  (procedure scene-procedure))

(set-record-type-printer! <scene>
  (lambda (record port)
    (format port "#<scene ~a>" (scene-name record))))


;;; Scene Procedures

(define (display-scene scene . args)
  (apply (scene-procedure scene) args))

(define (run-scene scene . args)
  (apply play-game
	 (cons (scene-procedure scene) args)))
